# To rebuild
# edit /usr/lib/python3.13/site-packages/rust2rpm/project/local.py
#    In temp_project_copy, change `shutil.copytree(path, target, dirs_exist_ok=True)`
# git clone --recurse-submodule https://github.com/z4yx/pam_rssh.git
# cd pam_rssh/deps/ssh-agent.rs
# rust2rpm --path Cargo.toml -V auto -o OUT
# cd ..
# Add `license = "MIT"` to Cargo.toml
# rust2rpm --path Cargo.toml -V auto -o OUT
# { cargo2rpm --path Cargo.toml buildrequires; cargo2rpm --path dep/ssh-agent.rs/Cargo.toml buildrequires  } | sort

%define pam_rssh_version	1.2.0
#% define pam_rssh_version_rc	0
%define pam_rssh_filename	pam_rssh-%{pam_rssh_version}%{?pam_rssh_version_rc:-rc%{pam_rssh_version_rc}}
%define ssh_agent_filename	ssh-agent.rs-802b94c

%bcond_with check

Name:		pam_rssh
Version:	%{pam_rssh_version}%{?pam_rssh_version_rc:~rc%{pam_rssh_version_rc}}
Release:	1%{?dist}
Summary:	PAM module providing ssh-agent based authentication

License:	MIT
URL:		https://github.com/z4yx/pam_rssh
Source0:	%{pam_rssh_filename}.tar.gz
Source1:	%{pam_rssh_filename}-vendor.tar.xz
Source2:	%{ssh_agent_filename}.tar.xz
Source3:	%{ssh_agent_filename}-vendor.tar.xz

BuildRequires:	pam-devel
BuildRequires:	cargo-rpm-macros >= 24

BuildRequires:	(crate(base64/default) >= 0.22.1 with crate(base64/default) < 0.23.0~)
BuildRequires:	(crate(byteorder/default) >= 1.5.0 with crate(byteorder/default) < 2.0.0~)
BuildRequires:	(crate(log/default) >= 0.4.0 with crate(log/default) < 0.5.0~)
BuildRequires:	(crate(log/serde) >= 0.4.0 with crate(log/serde) < 0.5.0~)
BuildRequires:	(crate(log/std) >= 0.4.0 with crate(log/std) < 0.5.0~)
BuildRequires:	(crate(openssl-sys/default) >= 0.9.0 with crate(openssl-sys/default) < 0.10.0~)
BuildRequires:	(crate(openssl/default) >= 0.10.0 with crate(openssl/default) < 0.11.0~)
BuildRequires:	(crate(pwd/default) >= 1.0.0 with crate(pwd/default) < 2.0.0~)

# For ssh-agent
BuildRequires:	(crate(byteorder/default) >= 1.2.7 with crate(byteorder/default) < 2.0.0~)
BuildRequires:	(crate(log/default) >= 0.4.6 with crate(log/default) < 0.5.0~)
BuildRequires:	(crate(serde/default) >= 1.0.87 with crate(serde/default) < 2.0.0~)
BuildRequires:	(crate(serde/derive) >= 1.0.87 with crate(serde/derive) < 2.0.0~)

%description

This PAM module provides ssh-agent based authentication. The primary design
goal is to avoid typing password when you sudo on remote servers. Instead,
you can simply touch your hardware security key (e.g. Yubikey/Canokey) to
fulfill user verification. The process is done by forwarding the remote
authentication request to client-side ssh-agent as a signature request.

This project is developed in Rust language to minimize security flaws.

%prep
%autosetup -n %{pam_rssh_filename}
pushd .
%setup -q -D -T -n %{pam_rssh_filename}/dep -a 2 -a 3
popd
%setup -q -D -T -n %{pam_rssh_filename} -a 1
sed -i -e '/^[[:space:]]*\[package\]/ a license = "MIT"' Cargo.toml
%cargo_prep -v vendor

%build
%cargo_build
%{cargo_license_summary}
%{cargo_license} > LICENSE.dependencies
pushd dep/ssh-agent.rs
%{cargo_license} >> ../../LICENSE.dependencies
popd

%install
%cargo_install
install -Dm 755 target/release/libpam_rssh.so $RPM_BUILD_ROOT%{_libdir}/security/pam_rssh.so

%if %{with check}
%check
%cargo_test
%endif

%files
%license LICENSE
%license LICENSE.dependencies
%doc README.md
%{_libdir}/security/*.so

%changelog
* Sun Jul 13 2025 Philippe Troin  <phil@fifi.org> - 1.2.0-1
- Upstream updated to 1.2.0.
- Update vendor tarballs and BuildRequires.

* Mon Apr 28 2025 Philippe Troin  <phil@fifi.org> - 1.2.0-rc2-1
- Created.
